/* 
 * Copyright 1997-2005 NComm, Inc.  All rights reserved.
 * 
 *
 *                     *** Important Notice ***
 * The software contained in this file may only be used within a 
 * valid license agreement between your company and NComm, Inc. 
 * The license agreement includes the definition of a PROJECT which 
 * defines the scope that this software can be used in.  Any use outside of
 * the definition of the PROJECT is prohibited without executing an additional 
 * agreement with NComm, Inc. Please refer to you license agreement for 
 * the definition of the PROJECT.
 *
 * Verification of your company's license agreement and copies of 
 * that agreement also may be obtained from:
 *
 * NComm, Inc.
 * 254 N Broadway
 * Suite 106
 * Salem, NH 03079
 * (603) 893-6186
 * sales@ncomm.com
 *
 */


#ifndef DS26528_H
#define DS26528_H

typedef volatile unsigned char VUC;
typedef unsigned char UC;

#define VUC_FIELD(a, b, c) (((a) & (0xff >> (8 - (c)))) << (b))



typedef struct {

struct _te1span {
/*************************************************************************
 * Per Port Section
 *************************************************************************
*/

/*************************************************************************
 * Framer Receive Side
 *************************************************************************
*/
	VUC hole[16]; 	/* 0 - 00F */

	VUC rhc;	/* 010 */
#define RHC_RCRCD	(1 << 7)
#define RHC_RHR		(1 << 6)
#define RHC_RHMS	(1 << 5)
#define RHC_RHCS(x)	VUC_FIELD(x, 0, 5)

	VUC rhbse;	/* 011 */
#define RHBSE_RCM(x)	VUC_FIELD(x, 0, 5)

	VUC rdsosel;	/* 012 */
#define RDS0SEL_RCM(x)	VUC_FIELD(x, 0, 5)

	VUC rsigc;	/* 013 */
#define RSIGC_RFSA1	(1 << 4)
#define RSIGC_RSFF	(1 << 2)
#define RSIGC_RSFE	(1 << 1)
#define RSIGC_RSIE	(1 << 0)

#define RSIGC_CASMS	(1 << 4)

	VUC rcr2;	/* 014 */
#define RCR2_RSLC96	(1 << 4)
#define RCR2_OOF(x)	VUC_FIELD(x, 2, 2)
#define RCR2_RAIIE 	(1 << 1)
#define RCR2_RD4RM	(1 << 0)

#define RCR2_RSA4IM	(1 << 4)
#define RCR2_RSA5IM	(1 << 3)
#define RCR2_RSA6IM	(1 << 2)
#define RCR2_RSA7IM	(1 << 1)
#define RCR2_RSA8IM	(1 << 0)

	VUC rbocc;	/* 015 */
#define RBOCC_RBR	(1 << 7)
#define RBOCC_RBD(x)	VUC_FIELD(x, 4, 2)
#define RBOCC_RBF(x)	VUC_FIELD(x, 1, 2)

	VUC hole2[10];	/* 016 - 01F */

	VUC ridr[32];	/* 020 - 040 */

	VUC rs[16];	/* 040 - 04F */

	VUC lcvcr1;	/* 050 */
#define LCVCR1_LCVC(x)	VUC_FIELD(x, 1, 7)
#define LCVCR1_LCCV8	(1 << 0)

	VUC lcvcr2;	/* 051 */
#define LCVCR2_(x)	VUC_FIELD(x, 0, 8)

	VUC pcvcr1;	/* 052 */
#define PCVCR1_PCVC(x)	VUC_FIELD(x, 0, 8)

	VUC pcvcr2;	/* 053 */
#define PCVCR2_PCVC(x)	VUC_FIELD(x, 0, 8)

	VUC foscr1;	/* 054 */
#define FOSCR1_FOS(x)	VUC_FIELD(x, 0, 8)

	VUC foscr2;	/* 055 */
#define FOSCR2_FOS(x)	VUC_FIELD(x, 0, 8)

	VUC ebcr1;	/* 056 */
	
	VUC ebcr2;	/* 057 */

	VUC hole6[8];	/* 058 - 05F */

	VUC rdsom; 	/* 060 */
#define RDSOM_B(x)	VUC_FIELD(x, 0, 8)

	VUC hole7; 	/* 061 */

	VUC rfdl_rrts7;	/* 062 */
#define RFDL_RFDL(x)	VUC_FIELD(x, 0, 8)

#define RRTS7_CSC5(x)	VUC_FIELD(x, 3, 5)
#define RRTS7_CRC4SA	(1 << 2)
#define RRTS7_CASSA	(1 << 1)
#define RRTS7_CFASSA	(1 << 0)

	VUC rboc;	/* 063 */
#define RBOC_RBOC(x)	VUC_FIELD(x, 0, 6)

	VUC rslc1_raf; 	/* 064 */
#define RAF_SI		(1 << 7)

	VUC rslc2_rnaf;  	/* 065 */
#define RNAF_SI		(1 << 7)
#define RNAF_A		(1 << 5)
#define RNAF_SA4	(1 << 4)
#define RNAF_SA5	(1 << 3)
#define RNAF_SA6	(1 << 2)
#define RNAF_SA7	(1 << 1)
#define RNAF_SA8	(1 << 0)

	VUC rslc3_rsiaf; /* 066 */
	
	VUC rsinaf;	/* 067 */

	VUC rra;	/* 068 */
	
	VUC rsa4;	/* 069 */

	VUC rsa5;	/* 06A */

	VUC rsa6;	/* 06B */

	VUC rsa7;	/* 06C */

	VUC rsa8;	/* 06D */

	VUC sabits;	/* 06E */

	VUC sa6code;	/* 06F */

	VUC hole8[16]; 	/* 070 - 07F */

	VUC rmmr; 	/* 080 */
#define RMMR_FRM_EN	(1 << 7)
#define RMMR_INIT_DONE	(1 << 6)
#define RMMR_SFTRST	(1 << 1)
#define RMMR_T1E1	(1 << 0)

	VUC rcr1; /* 081 */
#define RCR1_SYNCT	(1 << 7)
#define RCR1_RB8ZS	(1 << 6)
#define RCR1_RFM	(1 << 5)
#define RCR1_ARC	(1 << 4)
#define RCR1_SYNCC	(1 << 3)
#define RCR1_RJC	(1 << 2)
#define RCR1_SYNCE	(1 << 1)
#define RCR1_RESYNC	(1 << 0)

#define RCR1_RHDB3	(1 << 6)
#define RCR1_RSIGM	(1 << 5)
#define RCR1_RG802	(1 << 4)
#define RCR1_RCRC4	(1 << 3)
#define RCR1_FRC	(1 << 2)

	VUC ribcc_rcr2; /* 082 */
#define RIBCC_RUP(x)	VUC_FIELD(x, 3, 3)
#define RIBCC_RDN(x)	VUC_FIELD(x, 0, 3)

#define RCR2_RSAS(x)	VUC_FIELD(x, 3, 5)
#define RCR2_RLOSA	(1 << 0)

	VUC rcr3; /* 083 */
#define RCR3_IDF	(1 << 7)
#define RCR3_RSERC	(1 << 5)
#define RCR3_RLB	(1 << 2)
#define RCR3_PLB	(1 << 1)
#define RCR3_FLB	(1 << 0)

	VUC riocr;	/* 084 */
#define RIOCR_RCLKINV	(1 << 7)
#define RIOCR_RSYNCINV	(1 << 6)
#define RIOCR_H100EN	(1 << 5)
#define RIOCR_RSCLKM	(1 << 4)
#define RIOCR_RSMS	(1 << 3)
#define RIOCR_RSIO	(1 << 2)
#define RIOCR_RSMS2	(1 << 1)
#define RIOCR_RSMS1	(1 << 0)

	VUC rescr;	/* 085 */
#define RESCR_RDATFMT	(1 << 7)
#define RESCR_RGCLKEN	(1 << 6)
#define RESCR_RSZS	(1 << 4)
#define RESCR_RESALGN	(1 << 3)
#define RESCR_RESR	(1 << 2)
#define RESCR_RESMDM	(1 << 1)
#define RESCR_RESE	(1 << 0)

	VUC ercnt;	/* 086 */
#define ERCNT_1SECS	(1 << 7)
#define ERCNT_MCUS	(1 << 6)
#define ERCNT_MECU	(1 << 5)
#define ERCNT_ECUS	(1 << 4)
#define ERCNT_EAMS	(1 << 3)
#define ERCNT_FSBE	(1 << 2)
#define ERCNT_MOSCRF	(1 << 1)
#define ERCNT_LCVCRF	(1 << 0)

	VUC rhfc;	/* 087 */
#define RHFC_RFHWM(x)	VUC_FIELD(x, 0, 2)

	VUC riboc;	/* 088 */
#define RIBOC_IBS(x)	VUC_FIELD(x, 5, 2)
#define RIBOC_IBOSEL	(1 << 4)
#define RIBOC_IBOEN	(1 << 3)
#define RIBOC_DA(x)	VUC_FIELD(x, 0, 3)

	VUC rscc;	/* 089 */
#define RSCC_RSC(x)	VUC_FIELD(x, 0, 3)

	VUC rxpc;	/* 08A */

	VUC rbpbs;	/* 08B */
#define RBPBS_BPBSE(x)	VUC_FIELD(x, 0, 8)

	VUC hole9[2];	/* 08C - 08D */

	VUC rtest5;	/* 08E */
#define RTEST5_RTD(x)	VUC_FIELD(x, 0, 8)

	VUC rtest6;	/* 08F */
#define RTEST6_RHRTE	(1 << 7)
#define RTEST6_RLRTE	(1 << 6)
#define RTEST6_ISTML	(1 << 3)
#define RTEST6_ISTLL	(1 << 2)
#define RTEST6_FTML	(1 << 1)
#define RTEST6_FTLL	(1 << 0)

	VUC rls1;	/* 090 */
#define RLS1_RRAIC	(1 << 7)
#define RLS1_RAISC	(1 << 6)
#define RLS1_RLOSC	(1 << 5)
#define RLS1_RLOFC	(1 << 4)
#define RLS1_RRAID	(1 << 3)
#define RLS1_RAISD	(1 << 2)
#define RLS1_RLOSD	(1 << 1)
#define RLS1_RLOFD	(1 << 0)

	VUC rls2;	/* 091 */
#define RLS2_RPDV	(1 << 7)
#define RLS2_COFA 	(1 << 5)
#define RLS2_8ZD 	(1 << 4)
#define RLS2_16ZD	(1 << 3)
#define RLS2_SEFE	(1 << 2)
#define RLS2_B8ZS	(1 << 1)
#define RLS2_FBE	(1 << 0)

#define RLS2_CRCRC	(1 << 6)
#define RLS2_CASRC	(1 << 5)
#define RLS2_FASRC	(1 << 4)
#define RLS2_RSA(x)	VUC_FIELD(x, 2, 2)
#define RLS2_RCMF	(1 << 1)
#define RLS2_RAF	(1 << 0)

	VUC rls3;	/* 092 */
#define RLS3_LORCC 	(1 << 7)
#define RLS3_LSPC	(1 << 6)
#define RLS3_LDNC 	(1 << 5)
#define RLS3_LUPC	(1 << 4)
#define RLS3_LORCD	(1 << 3)
#define RLS3_LSPD	(1 << 2)
#define RLS3_LDND	(1 << 1)
#define RLS3_LUPD	(1 << 0)

	VUC rls4;	/* 093 */
#define RLS4_RESF	(1 << 7)
#define RLS4_RESEM	(1 << 6)
#define RLS4_RSLIP	(1 << 5)
#define RLS4_RSCOS	(1 << 3)
#define RLS4_1SEC	(1 << 2)
#define RLS4_TIMER	(1 << 1)
#define RLS4_RMF	(1 << 0)

	VUC rls5;	/* 094 */
#define RLS5_ROVR	(1 << 5)
#define RLS5_RHOBT	(1 << 4)
#define RLS5_RPE	(1 << 3)
#define RLS5_RPS	(1 << 2)
#define RLS5_RHWMS	(1 << 1)
#define RLS5_RNES	(1 << 0)

	VUC hole10;	/* 095 */

	VUC rls7;	/* 096 */
#define RLS7_RRAICI	(1 << 5)
#define RLS7_RAISCI	(1 << 4)
#define RLS7_RSLC96	(1 << 3)
#define RLS7_RFDLF	(1 << 2)
#define RLS7_BC		(1 << 1)
#define RLS7_BD		(1 << 0)

	VUC hole11;	/* 097 */

	VUC rss[3];	/* 098 - 09A */

	VUC hole12;	/* 09B */

	VUC rspcd1;	/* 09C */
#define RSPCD1_C(x)	VUC_FIELD(x, 0, 8)

	VUC rspcd2;	/* 09D */
#define RSPCD2_C(x)	VUC_FIELD(x, 0, 8)

	VUC hole13;	/* 09E */

	VUC riir;	/* 09F */
#define RIIR_RLS(x)	VUC_FIELD(x, 0, 7)

	VUC rim1;	/* 0A0 */
#define RIM1_RRAIC	(1 << 7)
#define RIM1_RAISC	(1 << 6)
#define RIM1_RLOSC	(1 << 5)
#define RIM1_RLOFC	(1 << 4)
#define RIM1_RRAID	(1 << 3)
#define RIM1_RAISD	(1 << 2)
#define RIM1_RLOSD	(1 << 1)
#define RIM1_RLOFD	(1 << 0)

	VUC rim2;	/* 0A1 */
#define RIM2_RSA1	(1 << 3)
#define RIM2_RSA0	(1 << 2)
#define RIM2_RCMF	(1 << 1)
#define RIM2_RAF	(1 << 0)

	VUC rim3;	/* 0A2 */
#define RIM3_LORCC	(1 << 7)
#define RIM3_LSPC	(1 << 6)
#define RIM3_LDNC	(1 << 5)
#define RIM3_LUPC	(1 << 4)
#define RIM3_LORCD	(1 << 3)
#define RIM3_LSPD	(1 << 2)
#define RIM3_LDND	(1 << 1)
#define RIM3_LUPD	(1 << 0)

	VUC rim4;	/* 0A3 */
#define RIM4_RESF	(1 << 7)
#define RIM4_RESEM	(1 << 6)
#define RIM4_RSLIP	(1 << 5)
#define RIM4_RSCOS	(1 << 4)
#define RIM4_1SEC	(1 << 2)
#define RIM4_TIMER	(1 << 1)
#define RIM4_RMF	(1 << 0)

	VUC rim5;	/* 0A4 */
#define RIM5_ROVR	(1 << 5)
#define RIM5_RHOBT	(1 << 4)
#define RIM5_RPE	(1 << 3)
#define RIM5_RPS	(1 << 2)
#define RIM5_RHWMS	(1 << 1)
#define RIM5_RNES	(1 << 0)

	VUC hole15;	/* 0A5 */

	VUC rim7;	/* 0A6 */
#define RIM7_RRAICI	(1 << 5)
#define RIM7_RAISCI	(1 << 4)
#define RIM7_RSLC96	(1 << 3)
#define RIM7_RFDLF	(1 << 2)
#define RIM7_BC		(1 << 1)
#define RIM7_BD		(1 << 0)
#define RIM7_SA6CD	(1 << 1)
#define RIM7_SAXCD	(1 << 0)

	VUC hole16;	/* 0A7 */

	VUC rscse[4];	/* 0A8 - 0AB */

	VUC rupcd1;	/* 0AC */
#define RUPCD_C(x)	VUC_FIELD(x, 0, 8)

	VUC rupcd2;	/* OAD */
#define RUPCD2_C(x)	VUC_FIELD(x, 0, 8)

	VUC rdncd1;	/* 0AE */
#define RDNCD1_C(x)	VUC_FIELD(x, 0, 8)

	VUC rdncd2;	/* 0AF */
#define RDNCD2_C(x)	VUC_FIELD(x, 0, 8)

	VUC rrts1;	/* 0B0 */
#define RRTS1_RRAI	(1 << 3)
#define RRTS1_RAIS	(1 << 2)
#define RRTS1_RLOS	(1 << 1)
#define RRTS1_RLOF	(1 << 0)

	VUC hole18;	/* 0B1 */

	VUC rrts3;	/* 0B2 */
#define RRTS3_LORC	(1 << 3)
#define RRTS3_LSP	(1 << 2)
#define RRTS3_LDN	(1 << 1)
#define RRTS3_LUP	(1 << 0)

#define RRTS3_V52LNK	(1 << 1)
#define RRTS3_RDMA	(1 << 0)

	VUC hole19;	/* 0B3 */

	VUC rrts5;	/* 0B4 */
#define RRTS5_PS(x)	VUC_FIELD(x, 4, 3)
#define RRTS5_RHWM	(1 << 1)
#define RRTS5_RNE	(1 << 0)

	VUC rhpba;	/* 0B5 */
#define RHPBA_MS 	(1 << 7)
#define RHPBA_RPBA(x)	VUC_FIELD(x, 7, 0)

	VUC rhf;	/* 0B6 */
#define RHF_RHD(x)	VUC_FIELD(x, 0, 8)

	VUC hole20[9];	/* 0B7 - 0B5 */

	VUC rbcs[4];	/* 0C0 - 0C3 */

	VUC rcbr[4];	/* 0C4 - 0C7 */

	VUC rsi[4];	/* 0C8 - 0CB */

	VUC rgccs[4];	/* OCC - 0CF */

	VUC rcice[4];	/* ODO - 0D3 */

	VUC rbpcs[4];	/* 0D4 - 0D7 */

	VUC hole22[24];	/* 0D8 - 0EF */

	
/*************************************************************************
 * End Framer Receive Side
 *************************************************************************
*/

/*************************************************************************
 * Global Register Map Section
 *************************************************************************
*/
	VUC gtcr1; 	/* 00f0 */
#define GTCR1_RLOFLTS	(1 << 5)
#define GTCR1_GIBO	(1 << 4)
#define GTCR1_BWE	(1 << 2)
#define GTCR1_GCLE	(1 << 1)
#define GTCR1_GIPI	(1 << 0)

	VUC gfcr;	/* 00f1 */
#define GFCR_IBOMS(x)	VUC_FIELD(x, 6, 2)
#define GFCR_BPCLK(x)	VUC_FIELD(x, 4, 2)
#define GFCR_RLOSSFS	(1 << 3)
#define GFCR_RFMSS	(1 << 2)
#define GFCR_TCBCS	(1 << 1)
#define GFCR_RCBCS	(1 << 0)

	VUC gtcr2;	/* 00f2 */
#define GTCR2_LOSS	(1 << 2)
#define GTCR2_TSSYNIOSEL (1 << 1)

	VUC gtccr;	/* 00f3 */
#define GTCCR_BPREFSEL(x) VUC_FIELD(x, 4, 4)
#define GTCCR_BPFREQSEL	(1 << 3)
#define GTCCR_FREQSEL	(1 << 2)
#define GTCCR_MPS(x)	VUC_FIELD(x, 0, 2)

	VUC hole101;	/* 00f4 */

	VUC glsrr;	/* 00f5 */

	VUC gfsrr;	/* 00f6 */

	VUC hole102;	/* 00f7 */
	
	VUC dimd;	/* 00f8 */

	VUC gfisr;	/* 00f9 */

	VUC gbisr;	/* 00fa */

	VUC glisr;	/* 00fb */

	VUC gfimr;	/* 00fc */

	VUC gbimr;	/* 00fd */

	VUC glimr;	/* 00fe */

	VUC hole103;	/* 00ff */


/*************************************************************************
 * End Global Register Map Section
 *************************************************************************
*/


/*************************************************************************
 * Framer Transmit Side
 *************************************************************************
*/
	VUC hole200[16];/* 100 - 10F */

	VUC thc1;	/* 110 */
#define THC1_NOFS	(1 << 7)
#define THC1_TEOML	(1 << 6)
#define THC1_THR	(1 << 5)
#define THC1_THMS	(1 << 4)
#define THC1_TFS	(1 << 3)
#define THC1_TEOM	(1 << 2)
#define THC1_TZSD	(1 << 1)
#define THC1_TCRCD	(1 << 0)

	VUC thbse;	/* 111 */
#define THBSE_TBSE(x)	VUC_FIELD(x, 0, 8)

	VUC hole201;	/* 112 */

	VUC thc2;	/* 113 */
#define THC2_TABT	(1 << 7)
#define THC2_SBOC	(1 << 6)
#define THC2_THCEN	(1 << 5)
#define THC2_THCS(x)	VUC_FIELD(x, 0, 5)

	VUC tsacr;	/* 114 */
#define TSACR_SIAF	(1 << 7)
#define TSACR_SINAF	(1 << 6)
#define TSACR_RA	(1 << 5)
#define TSACR_SA4	(1 << 4)
#define TSACR_SA5	(1 << 3)
#define TSACR_SA6	(1 << 2)
#define TSACR_SA7	(1 << 1)
#define TSACR_SA8	(1 << 0)
	
	VUC hole202[3];	/* 115 - 117 */

	VUC ssie[4];	/* 118 - 11B */

	VUC ttest[4];	/* 11C - 11F */

	VUC tidr[32];	/* 120 - 13F */
#define TIDR_C(x)	VUC_FIELD(x, 0, 8)

	VUC ts[16];	/* 140 - 14F */

	VUC tcice[4];	/* 150 - 153 */

	VUC hole206[14];/* 154 - 161 */

	VUC tfdl;	/* 162 */
#define TFDL_TFDL(x)	VUC_FIELD(x, 0, 8)

	VUC tboc;	/* 163 */
#define TBOC_TBOC(x)	VUC_FIELD(x, 0, 6)

	VUC tslc1_taf;	/* 164 */
#define TAF_SI		(1 << 7)
	
	VUC tslc2_tnaf;	/* 165 */
#define TNAF_SI		(1 << 7)
#define TNAF_A		(1 << 5)
#define TNAF_SA4	(1 << 4)
#define TNAF_SA5	(1 << 3)
#define TNAF_SA6	(1 << 2)
#define TNAF_SA7	(1 << 1)
#define TNAF_SA8	(1 << 0)

	VUC tslc3_tsiaf;/* 166 */
	
	VUC tsinaf;	/* 167 */
	
	VUC tra;	/* 168 */

	VUC tsa4;	/* 169 */

	VUC tsa5;	/* 16A */

	VUC tsa6;	/* 16B */

	VUC tsa7;	/* 16C */

	VUC tsa8;	/* 16D */

	VUC hole207[18];/* 16E - 17F */

	VUC tmmr;	/* 180 */
#define TMMR_FRM_EN 	(1 << 7)
#define TMMR_INIT_DONE	(1 << 6)
#define TMMR_SFTRST	(1 << 1)
#define TMMR_T1E1	(1 << 0)

	VUC tcr1;	/* 181 */	
#define TCR1_TJC	(1 << 7)
#define TCR1_TFPT	(1 << 6)
#define TCR1_TCPT	(1 << 5)
#define TCR1_TSSE	(1 << 4)
#define TCR1_GB7S	(1 << 3)
#define TCR1_TB8ZS	(1 << 2)
#define TCR1_TAIS	(1 << 1)
#define TCR1_TRAI	(1 << 0)

#define TCR1_TTPT	(1 << 7)
#define TCR1_T16S	(1 << 6)
#define TCR1_TG802	(1 << 5)
#define TCR1_TSIS	(1 << 4)
#define TCR1_TSA1	(1 << 3)
#define TCR1_THDB3	(1 << 2)
#define TCR1_TAIS	(1 << 1)
#define TCR1_TCRC4	(1 << 0)
	
	VUC tcr2;	/* 182 */
#define TCR2_TFDLS	(1 << 7)
#define TCR2_TSLC96	(1 << 6)
#define TCR2_FBCT(x)	VUC_FIELD(x, 3, 2)
#define TCR2_TD4RM	(1 << 2)
#define TCR2_PDE	(1 << 1)
#define TCR2_TB7ZS	(1 << 0)

#define TCR2_AEBE	(1 << 7)
#define TCR2_AAIS	(1 << 6)
#define TCR2_ARA	(1 << 5)
#define TCR2_SA4S	(1 << 4)
#define TCR2_SA5S	(1 << 3)
#define TCR2_SA6S	(1 << 2)
#define TCR2_SA7S	(1 << 1)
#define TCR2_SA8S	(1 << 0)

	VUC tcr3;	/* 183 */
#define TCR3_ODF	(1 << 7)
#define TCR3_ODM	(1 << 6)
#define TCR3_TCSS(x)	VUC_FIELD(x, 4, 2)
#define TCR3_MFRS	(1 << 3)
#define TCR3_TFM	(1 << 2)
#define TCR3_IBVD	(1 << 1)
#define TCR3_TLOOP	(1 << 0)

#define TCR3_CRC4R	(1 << 0)

	VUC tiocr;	/* 184 */
#define TIOCR_TCLKINV	(1 << 7)
#define TIOCR_TSYNCINV	(1 << 6)
#define TIOCR_TSSYNCINV	(1 << 5)
#define TIOCR_TSCLKM	(1 << 4)
#define TIOCR_TSSM	(1 << 3)
#define TIOCR_TSIO	(1 << 2)
#define TIOCR_TSDW	(1 << 1)
#define TIOCR_TSM	(1 << 0)

	VUC tescr;	/* 185 */
#define TESCR_TDATFMT	(1 << 7)
#define TESCR_TGCLKEN	(1 << 6)
#define TESCR_TDATAEN	(1 << 5)
#define TESCR_TSZS	(1 << 4)
#define TESCR_TESALGN	(1 << 3)
#define TESCR_TESR	(1 << 2)
#define TESCR_TESMDM	(1 << 1)
#define TESCR_TESE	(1 << 0)

	VUC tcr4;	/* 186 */
#define TCR4_TRAIM	(1 << 3)
#define TCR4_TAISM	(1 << 2)
#define TCR4_TC(x)	VUC_FIELD(x, 0, 2)

	VUC thfc;	/* 187 */
#define THFC_TFLWM(x)	VUC_FIELD(x, 0, 2)

	VUC tiboc;	/* 188 */
#define TIBOC_IBS(x)	VUC_FIELD(x, 5, 2)
#define TIBOC_IBOSEL	(1 << 4)
#define TIBOC_IBOEN	(1 << 3)
#define TIBOC_DA(x)	VUC_FIELD(x, 0, 3)

	VUC tds0sel;	/* 189 */
#define TDS0SEL_TCM(x)	VUC_FIELD(x, 0, 5)

	VUC txpc;	/* 18A */
#define TXPC_THPBMS	(1 << 7)
#define TXPC_THPBEN	(1 << 6)
#define TXPC_THPAMS	(1 << 5)
#define TXPC_THPAEN	(1 << 4)
#define TXPC_TBPDIR	(1 << 2)
#define TXPC_TBPFUS	(1 << 1)
#define TXPC_TBPEN	(1 << 0)

	VUC tbbs;	/* 18B */
#define TBBS_BPBSE(x)	VUC_FIELD(x, 0, 8)

	VUC hole208[2];	/* 18D */

	VUC tsyncc;	/* 18E */
#define TSYNCC_TSEN	(1 << 2)
#define TSYNCC_SYNCE	(1 << 1)
#define TSYNCC_RESYNC	(1 << 0)

#define TSYNCC_CRC4	(1 << 3)

	VUC ttest5;	/* 18F */
#define TTEST5_TLRTE	(1 << 6)
#define TTEST5_FLBAISD	(1 << 1)
#define TTEST5_AISCIP	(1 << 0)

	VUC tls1;	/* 190 */
#define TLS1_TESF	(1 << 7)
#define TLS1_TESEM	(1 << 6)
#define TLS1_TSLIP	(1 << 5)
#define TLS1_TSLC96	(1 << 4)
#define TLS1_TPDV	(1 << 3)
#define TLS1_TMF	(1 << 2)
#define TLS1_LOTCC	(1 << 1)
#define TLS1_LOTC	(1 << 0)

#define TLS1_TAF	(1 << 3)

	VUC tls2;	/* 191 */
#define TLS2_TFDLE	(1 << 4)
#define TLS2_TUDR	(1 << 3)
#define TLS2_TMEND	(1 << 2)
#define TLS2_TLWMS	(1 << 1)
#define TLS2_TNFS	(1 << 0)

	VUC tls3;	/* 192 */
#define TLS3_LOF	(1 << 1)
#define TLS3_LOFD	(1 << 0)

	VUC hole209[12];/* 193 - 19E */

	VUC tiir;	/* 19F */
#define TIIR_TLS1	(1 << 0)
#define TIIR_TLS2	(1 << 1)
#define TIIR_TLS3	(1 << 2)

	VUC tim1;	/* 1A0 */
#define TIM1_TESF	(1 << 7)
#define TIM1_TESEM	(1 << 6)
#define TIM1_TSLIP	(1 << 5)
#define TIM1_TSLC96	(1 << 4)
#define TIM1_TPDV	(1 << 3)
#define TIM1_TMF	(1 << 2)
#define TIM1_LOTCC	(1 << 1)
#define TIM1_LOTC	(1 << 0)

#define TIM1_TAF	(1 << 3)

	VUC tim2;	/* 1A1 */
#define TIM2_TFDLE	(1 << 4)
#define TIM2_TUDR	(1 << 3)
#define TIM2_TMEND	(1 << 2)
#define TIM2_TLWMS	(1 << 1)
#define TIM2_TNFS	(1 << 0)

	VUC tim3;	/* 1A2 */
#define TIM3_LOFD	(1 << 0)

	VUC hole210[9];	/* 1A3 - 1AB */

	VUC tcd1;	/* 1AC */
#define TCD1_C(x)	VUC_FIELD(x, 0, 8)

	VUC tcd2;	/* 1AD */
#define TCD2_C(x)	VUC_FIELD(x, 0, 8)

	VUC hole211[3];	/* 1AE - 1B0 */

	VUC trts2;	/* 1B1 */
#define TRTS_TEMPTY	(1 << 3)
#define TRTS_TFULL	(1 << 2)
#define TRTS_TLWMM	(1 << 1)
#define TRTS_TNF	(1 << 0)

	VUC hole212;	/* 1B2 */

	VUC tfba;	/* 1B3 */
#define TFBA_TFBA(x)	VUC_FIELD(x, 0, 7)

	VUC thf;	/* 1B4 */
#define THF_THD(x)	VUC_FIELD(x, 0, 8)

	VUC hole213[6];	/* 1B5 - 1BA */

	VUC tdsom;	/* 1BB */
#define TDSOM_B(x)	VUC_FIELD(x, 0, 8)

	VUC hole214[4];	/* 1BC - 1BF */

	VUC tbcs[4];	/* 1C0 - 1C3 */

	VUC tcbr[4];	/* 1C4 - 1C7 */

	VUC thscs[4];	/* 1C8 - 1CB */

	VUC tgccs[4];	/* 1CC - 1CF */

	VUC pcl[4];	/* 1D0 - 1D3 */

	VUC tbpcs[4];	/* 1D4 - 1D7*/

	VUC hole217[40];/* 1D8 - 1FF */
	
	
	
/*************************************************************************
 * End Framer Transmit Side
 *************************************************************************
*/



/*************************************************************************
 * End Per Port Section
 *************************************************************************
*/

} te1[8];

	struct _bertliu{
/*************************************************************************
 * LIU Section
 *************************************************************************
*/
	struct _liu {
		
	VUC ltrcr;	/* 1000 */
#define LTRCR_JADS	(1 << 4)
#define LTRCR_JAPS(x)	VUC_FIELD(x, 2, 2)
#define LTRCR_T1J1E1	(1 << 1)
#define LTRCR_LSC	(1 << 0)

	VUC ltitsr;	/* 1001 */
#define LTITSR_TIMPTOFF	(1 << 6)
#define LTITSR_TIMPL(x)	VUC_FIELD(x, 4, 2)
#define LTITSR_TS(x)	VUC_FIELD(x, 0, 3)

	VUC lmcr;	/* 1002 */
#define LMCR_TAIS	(1 << 7)
#define LMCR_ATAIS	(1 << 6)
#define LMCR_LLB	(1 << 5)
#define LMCR_ALB	(1 << 4)
#define LMCR_RLB	(1 << 3)
#define LMCR_TPDE	(1 << 2)
#define LMCR_RPDE	(1 << 1)
#define LMCR_TE		(1 << 0)

	VUC lrsr;	/* 1003 */
#define LRSR_OEQ	(1 << 5)
#define LRSR_UEQ	(1 << 4)
#define LRSR_JALTS	(1 << 3)
#define LRSR_SCS	(1 << 2)
#define LRSR_OCS	(1 << 1)
#define LRSR_LOSS	(1 << 0)

	VUC lsimr;	/* 1004 */
#define LSIMR_JALTRSIM	(1 << 7)
#define LSIMR_OCSRIM	(1 << 6)
#define LSIMR_SCSRIM	(1 << 5)
#define LSIMR_LOSRIM	(1 << 4)
#define LSIMR_JALTSSIM	(1 << 3)
#define LSIMR_OCSSIM	(1 << 2)
#define LSIMR_SCSSIM	(1 << 1)
#define LSIMR_LOSSIM	(1 << 0)

	VUC llsr;	/* 1005 */
#define LLSR_JFLTRLS	(1 << 7)
#define LLSR_OCRLS	(1 << 6)
#define LLSR_SCRLS	(1 << 5)
#define LLSR_LOSRLS	(1 << 4)
#define LLSR_JALTSLS	(1 << 3)
#define LLSR_OCSLS	(1 << 2)
#define LLSR_SCSLS	(1 << 1)
#define LLSR_LOSSLS	(1 << 0)

	VUC lrsl;	/* 1006 */
#define LRSL_RSL(x)	VUC_FIELD(x, 6, 2)

	VUC lrismr;	/* 1007 */
#define LRISMR_RG703	(1 << 7)
#define LRISMR_RIMPOFF	(1 << 6)
#define LRISMR_RIMPM(x)	VUC_FIELD(x, 4, 2)
#define LRISMR_RTR	(1 << 3)
#define LRISMR_RMONEN	(1 << 2)
#define LRISMR_RSMS(x)	VUC_FIELD(x, 0, 2)

	VUC hole[24];	/* 1008 - 101f */
	} liu[8];

/*************************************************************************
 * End LIU Section
 *************************************************************************
*/
/*************************************************************************
 * Bert Section
 *************************************************************************
*/
	struct _bert {

	VUC bawc;	/* 1100 */
#define BAWC_ACNT(x)	VUC_FIELD(x, 0, 8)

	VUC brp[4];	/* 1101 - 1104 */

	VUC bcr1;	/* 1105 */
#define BCR1_TC		(1 << 7)
#define BCR1_TINV	(1 << 6)
#define BCR1_RINV	(1 << 5)
#define BCR1_PS(x)	VUC_FIELD(x, 2, 3)
#define BCR1_LC		(1 << 1)
#define BCR1_RESYNC	(1 << 0)

	VUC bcr2;	/* 1106 */
#define BCR2_EIB(x)	VUC_FIELD(x, 5, 3)
#define BCR2_SBE	(1 << 4)
#define BCR2_RPL(x)	VUC_FIELD(x, 4, 0)

	VUC bbc[4];	/* 1107 - 110A */

	VUC bec[3];	/* 110B - 110D */

	VUC b0SR0;	/* 110E */
#define BOSRO_BBED	(1 << 6)
#define BOSRO_BBCO	(1 << 5)
#define BOSRO_BEC0	(1 << 4)
#define BOSRO_BRA(x)	VUC_FIELD(x, 2, 2)
#define BOSRO_BRLOS	(1 << 1)
#define BOSRO_BSYNC	(1 << 0)

	VUC simr;	/* 110F */

	} bert[8];

/*************************************************************************
 * End Bert Section
 *************************************************************************
*/
	} bertliu;


} DEVICE;

typedef struct _te1span FRAMER;
typedef struct _liu LIU;

/*
 *	Copyright 1997-2005 NComm, Inc.  All rights reserved.
 *	For technical support:
 *	Email: techsupport@ncomm.com
 *	603-893-6186 x67
 *	www.ncomm.com
 *
 *	The Device version is the chip revision that is supported by this
 *	driver.
 *
 *	Device Version:
 *		Rev 0
 *
 *	Revision:
 *		xx/xx/xx - Initial Release
 *
 *	See CUSTOMIZE HERE for areas that may need to be customized for your
 *	platform.
 */

/* -------------------------------------------------------------------------- */
/*
 * Driver for the DALLAS DS26528 chip, global section
 */

/* -------------------------------------------------------------------------- */
/* 
 * The following sections consists of defines for your platform as well
 * as how the DS26528 works in your system.
 * You need to review each of these sections.  All of the defines shown
 * here are what is required to operate this chip on one of NComms
 * evaluation platforms.  Your platform may require different settings.
 * The places that will be different are dependant upon the hardware
 * design of your platform.  The design team responsible for your
 * hardware platform will likely have the answers to any customizations that
 * are required.
 *
 * NComm recommends that you add a pound include line at the end of these
 * sections which contains an #undef of the items that need to be changed and
 * a subsequent #define that provides a different value.  This pound include 
 * file would then become a record of what changed between the standard NComm
 * driver distribution and your platform.  
 * See the line pound include "customizations_for_NCI_CHIP_NAME.h"
 * below for where this should be done.
 *
 */

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Platform Customizations Section
 * This section defines how the chip and driver interact with other parts
 * of your hardware.
 */

#define EDGE_TRIG_INTRPT	0	/* 0 = level triggered interrupts */
					/* level triggered is recommended */
					/* 1 = edge triggered */

#define USER_DEFINED_HOOKINT_VALUE 0	/* User defined value */
					/* A value that will be passed to the */
					/* application when a HOOKINTERRUPT is*/
					/* made.  This value is not used by */
					/* TMS nor the driver, just passed */

	/* 
	 * MAX_DEVICES defines the number of devices (hardware chips) you have
	 * in your system.  If you have less than the number shown, change
	 * this to the lower number.  If you have more, you want to change this
	 * to the higher value. Since there is an interrupt service routine per 
	 * device, when you get a larger number than NCI_MAX_DEVICES,
	 * you need to add the additional interrupt service routines.  The
	 * code is set up to generate a #warning when this happens.
	 */
#define MAX_DEVICES 4

	/* The following define controls if the standard CLIB functions
	 * memset and memcpy are used by the driver or
	 * the driver uses its own local routine for these functions.
	 * By default, the standard CLIB functions are used.
	 */
#undef USE_OWN_DRV_MEMLIB

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Chip Level CUSTOMIZATION Section
 * This set of defines control the global part of the driver.
 */

#define MAX_RESET_WAIT		0xfffff	/* Max Wait before error */

/* See GTCR1 Register 0F0H */
#define RLOFLTS_SELECT		0	/* 0 = RLOF/LOTCX pin = LOF */
					/* 1 = RLOF/LOTCX pin = LOC */

/* See GFCR Register 0F1H */
#define RCHBCS_SELECT		0	/* 0 = RCHBLK/CLK pins = RCHBLK */
					/* 1 = RCHBLK/CLK pins = RCHCLK */

#define TCHBCS_SELECT		0	/* 0 = TCHBLK/CLK pins = TCHBLK */
					/* 1 = TCHBLK/CLK pins = TCHCLK */

#define RFMSS_SELECT		0	/* 0 = RF/RMSYCC pins = RFSYNC */
					/* 1 = RF/RMSYCC pins = RMSYNC */

#define RLOSSFS_SELECT		0	/* 0 = RLOS/RSIGF pins = RLOS */
					/* 1 = RLOS/RSIGF pins = RSIGF */

#define BACKPLANE_CLOCK		0	/* BPCLK Frequency */
					/* 0 = 2.048 MHZ */
					/* 1 = 4.096 MHZ */
					/* 2 = 8.192 MHZ */
					/* 3 = 16.384 MHZ */

#define INTERLEAVE_MODE		0 	/* Interleave Bus Operation Mode */
					/* 0 = IBO mux disabled */
					/* 1 = 4.096 MHz (2 per) */
					/* 2 = 8.192 MHz (4 per) */
					/* 3 = 16.384 MHz (8 per) */

/* See GTCR2 Register 0F2H */
#define TSSYNIO_SELECT		1	/* 0 = TSSYNCIO pin is an input */
					/* 1 = TSSYNCIO pin is an 8Khz ouput */

#define LOS_SELECT		0 	/* 0 = LOS pins driven from Framer LOS*/
					/* 1 = LOS pins driven from LIU LOS */

/* See GTCCR Register 0F3H */
#define FREQUENCY_SELECT	0	/* See Master Period below */
					/* 0 = 2.048 Mhz Based */
					/* 1 = 1.544 Mhz Based */

#define MASTER_PERIOD		0	/* MCLK Frequency Base * multiplier */
					/* 0 = Base * 1 */
					/* 1 = Base * 2 */
					/* 2 = Base * 4 */
					/* 3 = Base * 8 */

#define BACKPLANE_REFERENCE	9	/* Reference clock */
					/* 0 = LIU RCLK 1 */
					/* 1 = LIU RCLK 2 */
					/* 2 = LIU RCLK 3 */
					/* 3 = LIU RCLK 4 */
					/* 4 = LIU RCLK 5 */
					/* 5 = LIU RCLK 6 */
					/* 6 = LIU RCLK 7 */
					/* 7 = LIU RCLK 8 */
					/* 8 = 1.544 MHZ from MCLK */
					/* 9 = 2.048 MHZ from MCLK */
					/* A = 1.544 MHZ from REFCLKIO */
					/* B = 2.048 MHZ from REFCLKIO */


#define BP_FREQUENCY_SELECT	0	/* Backplane FREQ */
					/* 0 = 2.048 Mhz Based */
					/* 1 = 1.544 Mhz Based */



/* See TCR3 Register 183H */
#define TX_UNIPOLAR		0	/* 0 = BIPOLAR Data transmitted */
					/* 1 = NRZ data transmitted at TPOS */

/* See RCR3 Register 083H */
#define RX_UNIPOLAR		0	/* 0 = BIPOLAR Data expected */
					/* 1 = NRZ data expected at RPOS */

/* See RCR1 Register 081H */
#define RESYNC_CRITERIA		0	/* 0 = Resync on OOF and LOS */
					/* 1 = Resync on OOF only */

#define SYNC_TIME		0	/* 0 = qualify in 10 bits */
					/* 1 = qualify in 24 bits */

/* See RCR2 Register 014H */
#define OOF_CRITERIA		0	/* 0 = 2/4 frame bits in error */
					/* 1 = 2/5 frame bits in error */	
					/* 2 = 2/6 frame bits in error */	
					/* 3 = 2/6 frame bits in error */

/* See RIOCR Register 084H */
#define RSYNC_MODE1		0	/* 0 = Frame mode */
					/* 1 = multiframer mode */

#define RSYNC_IO_SELECT		0	/* 0 = RSYNC is an output */
					/* 1 = RSYNC is an input */

#define RSYNC_SKIP		0	/* 0 = Output every multiframe */
					/* 1 = Output every other multiframe */

#define H100_MODE		0	/* 0 = Normal operation */
					/* 1 = RYSNC and TSSYNCIO are shifted */

#define RSYNC_INV		0	/* 0 = No inversion of RSYNC */
					/* 1 = Invert RSYNC */

#define RCLK_INV		0	/* 0 = No inversion of RCLK */
					/* 1 = Invert RCLK */

/* See RESCR Register 085H */
#define RX_ELASTIC_STORE_EN	1	/* 0 = RX elastic store bypassed */
					/* 1 = RX elastic store enabled */

#define RES_MIN_DELAY		0	/* 0 = Two frame depth */
					/* 1 = 32-bit depth */

#define RXS_ZONE_SEL		0	/* 0 = slip at 9 bytes or less */
					/* 1 = slip at 2 bytes or less */

#define GAP_CLOCK_EN		0	/* 0 = RCHCLK functions normally */
					/* 1 = Enable gapped bit clock */

#define RX_CHAN_FORMAT		0	/* 0 = 64 KBps all 8 bits */
					/* 1 = 56 KBps only 7 bits */


/* See ERCNT Register 086H */
#define LCV_SELECT		1	/* 0 = do not count EXZ */
					/* 1 = count EXZ */

#define MOS_COUNT_SELECT	0 	/* 0 = Count framing bit position errs*/
					/* 1 = Count multiframes out of SYNC */
					   
#define PCVCR_SELECT		1	/* 0 = only FT bit position errors */
					/* 1 = FS and FT bit position errors */

#define ERROR_ACU_MODE		0	/* 0 = Auto Update */
					/* 1 = Manual Update */

#define MANUAL_UPDATE_SEL	0	/* If manual update */
					/* 0 = use MECU bit */
					/* 1 = latch on LATCH_CNT signal */

#define ONE_SECOND_SEL		0	/* 0 = use internal 1 Sec timer */
					/* 1 = use external 1 Sec pin SEC_IN */

/* See RHFC Register 087H */
#define HIGH_WATER_MARK		1	/* 0 = 4 bytes */
					/* 1 = 16 bytes */
					/* 2 = 32 bytes */
					/* 3 = 48 butes */

/* See RIBOC Register 088H */
/* See TIBOC Register 088H */
#define DEVICE_ASSIGNMENT	0	/* 0 - 7 = device 1-8 on bus */

#define IBO_EN			0	/* 0 = Interleave Bus disabled */
					/* 1 = Interleave Bus Enabled */

#define IBO_SEL			0	/* 0 = Channel Interleave */
					/* 1 = Frame Interleave */

#define IBO_SIZE		0	/* 0 = 2 Devices on Bus */
					/* 1 = 4 Devices on Bus */
					/* 2 = 8 Devices on Bus */

/* See TIOCR Register 0184H */
#define TSYNC_MODE		0	/* 0 = Framer mode */
					/* 1 = multiframe mode */

#define TSYNC_DOUBLE_WIDE	0	/* 0 = no double wide pulse */
					/* 1 = pulse double wide in sig frames*/

#define TSYNC_IO		1	/* 0 = TSYNC is an input */
					/* 1 = TSYNC is an output */

#define TSSYNC_MODE		0	/* 0 = Framer mode */
					/* 1 = multiframe mode */

#define TSYNCIO_INV		0	/* 0 = do not invert TSSYNC */
					/* 1 = invert TSSYNC */

#define TSYNC_INV		0	/* 0 = do not invert TSYNC */
					/* 1 = invert TSYNC */

#define TCLK_INV		0	/* 0 = do not invert TCLK */
					/* 1 = invert TCLK */

					   
/* See TESCR Register 0185H */
#define TX_ELASTIC_STORE_EN	1	/* 0 = TX elastic store bypassed */
					/* 1 = TX elastic store enabled */

#define TES_MIN_DELAY		0	/* 0 = Two frame depth */
					/* 1 = 32-bit depth */

#define TXS_ZONE_SEL		0	/* 0 = slip at 9 bytes or less */
					/* 1 = slip at 2 bytes or less */

#define TDATA_EN		0	/* 0 = Normal Operation */
					/* 1 = TDATA pin is active */

#define TGAP_CLOCK_EN		0	/* 0 = TCHCLK functions normally */
					/* 1 = Enable gapped bit clock */

#define TX_CHAN_FORMAT		0	/* 0 = 64 KBps all 8 bits */
					/* 1 = 56 KBps only 7 bits */

/* See THFC Register 187H */
#define LOW_WATER_MARK		1	/* 0 = 4 bytes */
					/* 1 = 16 bytes */
					/* 2 = 32 bytes */
					/* 3 = 48 butes */

/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* T1 CUSTOMIZATION Section
 * This set of defines control the T1 part of the driver.
 */

/* See RIOCR Register 084H */
#define RSYNC_MODE2_T1		0	/* 0 = do not pulse double wide */
					/* 1 = pulse double wide */

#define RSYNC_CLK_MODE_T1	0	/* 0 = RSYSCLK = 1.544 Mhz */
					/* 1 = RSYSCLK = 2.048 Mhz */

/* See ERCNT Register 086H */
#define UPDATE_SELECT_T1	0 	/* 0 = Update on one second */
					/* 1 = Update at 42ms */
					   	
/* See TIOCR Register 0184H */
#define TSYSCLK_MODE_T1		0	/* 0 = TSYSCLK is 1.544 Mhz */
					/* 1 = TSYSCLK is 2.048 * n */

					
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* E1 CUSTOMIZATION Section
 * This set of defines control the E1 part of the driver.
 */

#define SASI_OSTICKER		0	/* ID for SASI Ticker */
#define SASI_POLL_TICK		50	/* in milliseconds */

/* See RIOCR Register 084H */
#define RSYNC_MODE2_E1		0	/* 0 = Output CAS multiframe bounds */
					/* 1 = Output CRC4 multiframe bounds */

#define RSYNC_CLK_MODE_E1	1	/* 0 = RSYSCLK = 1.544 Mhz */
					/* 1 = RSYSCLK = 2.048 Mhz */

/* See ERCNT Register 086H */
#define UPDATE_SELECT_E1	0 	/* 0 = Update on one second */
					/* 1 = Update at 62.5ms */

/* See TIOCR Register 0184H */
#define TSYSCLK_MODE_E1		1	/* 0 = TSYSCLK is 1.544 Mhz */
					/* 1 = TSYSCLK is 2.048 * n */

/* See LTITSR Register 0x1001 */
#define TX_IMPEDANCE		0	/* 0 = 75 Ohm */
					/* 1 = 120 Ohm */

/* See LRISMR Register 0x1007 */
#define RX_IMPEDANCE		0	/* 0 = 75 Ohm */
					/* 1 = 120 Ohm */

/* ------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* LIU CUSTOMIZATION Section
 * This set of defines control the LIU part of the driver.
 */

/* See LTRCR Register 1000H */
#define JAT_DEPTH		0	/* 0 = 128 bit depth */
					/* 1 = 32 bit depth */

#define JAT_POSITION		1	/* 0 = RX path */
					/* 1 = TX path */
					/* 2-3 = JAT not used */

#define LOS_CRITERIA		0	/* 0 = Use G.775 criteria */
					/* 1 = Use ETSI (300233) criteria */

/* See LTITSR Register 1001H */
#define TXTERM_OFF		0	/* 0 = TX termination ON */
					/* 1 = TX termination OFF */

/* See LRISMR Register 1007H */
#define RXTERM_OFF		0	/* 0 = RX termination ON */
					/* 1 = RX termination OFF */


/* -------------------------------------------------------------------------- */
/* CUSTOMIZE HERE
 * This is where you should put your pound include line to include your
 * own file to customize the drivers.  The file will want the form of:
 * #undef the name you want to change
 * #define the name to the value you need
 */

/* pound include "customizations_for_NCI_CHIP_NAME.h" */


/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*          You should not need to edit anything below this point.            */
/*          You should not need to edit anything below this point.            */
/*          You should not need to edit anything below this point.            */
/*          You should not need to edit anything below this point.            */
/*          You should not need to edit anything below this point.            */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */


#define MAX_T1_CHANNELS 8
#define MAX_E1_CHANNELS 8


/* -------------------------------------------------------------------------- */

#define MAX_GLOBAL_TICKERS 0

/*
 * MAX_GLOBAL_TICKERS defines the number of global ticker routines that are 
 * shared between each of the driver technologies.
 */

/* -------------------------------------------------------------------------- */
/* 
 * This section has some misc. defines 
 */

#ifndef NULL
	#define NULL ((void *)(0))
#endif

/* -------------------------------------------------------------------------- */
/*
 * This section contains the defines which are used by the differnt driver
 * files.
 */

/* Function Entry Points */
#define NCID_GDEVICEMAP _ds26528_GlobalDeviceMap
#define NCID_GDEVICEUNMAP _ds26528_GlobalDeviceUnMap
#define NCID_GRESET _ds26528_GlobalReset
#define NCID_GUNRESET _ds26528_GlobalUnReset
#define NCID_GHOOKISR _ds26528_GlobalHookIsr
#define NCID_GHOOKTICKER _ds26528_GlobalHookTicker
#define NCID_GTICKER _ds26528_GlobalTicker

/* -------------------------------------------------------------------------- */
/* 
 * This section defines the top level device strucucture for the device
 */

typedef enum _ds26528_tech_index {
	DRVR_IDX_T1 = (0),
	DRVR_IDX_E1 = (1),
	DRVR_IDX_END = 2
} NCID_TI; 

struct _ds26528_global {
	int onesec_hooked;
	unsigned long t1map;		/* Controls the T1 allocation */
	unsigned long e1map;		/* Controls the E1 allocation */
};

typedef struct _ds26528_Device {
	int init;			/* When 0, chip is not Mapped */
					/* When 1, chip is Mapped */
	int id;				/* Chip ID number */
	int mapCnt;			/* Number times chip has been mapped */
	int resetCnt;			/* Number of times chip has Global */
					/* reset called */
	void *BaseAdr;			/* Address of the chip */

					/* define the interrupt entry points */
	int (*tech_handlers[DRVR_IDX_END])();
	int isr_cnt;
	void *device_isr;		/* The actual ISR */

#if MAX_GLOBAL_TICKERS
	struct _tickers {
		int cnt;		/* number of times ticker allocated */
		void *handle;		/* Ticker handle */
		void (*tickerHandler[DRVR_IDX_END])
			(struct _ds26528_Device *, int ticker);
	} tickers[MAX_GLOBAL_TICKERS];
#endif /* MAX_GLOBAL_TICKERS */

	struct _ds26528_global chip;
} GDEVICE;

/* 
 * define the global level functions.  These functions may be called
 * from each driver component.
 */

extern int NCID_GDEVICEUNMAP(GDEVICE *d);
extern GDEVICE *NCID_GDEVICEMAP(void *baseaddr);
extern void NCID_GRESET(GDEVICE *d);
extern void NCID_GUNRESET(GDEVICE *d);
extern void NCID_GHOOKISR(GDEVICE *d, NCID_TI ti, int onoff, 
	void (*fooptr)(), void *LnPtr, void *isr);
extern void NCID_GHOOKTICKER(GDEVICE *d, NCID_TI ti, int ticker, int onoff,
	void (*fooptr)(), void *LnPtr, void *tech_handler);
extern void NCID_GRESOURCE(int res, int onoff,
	void *LnPtr, int fc, void *isr, int line);




#ifdef USE_OWN_DRV_MEMLIB
/*------------------------------------------------------------------------*/
/* Define the driver specific memset call so that we have a self
 * contained driver.
 */
static void drvMemset(void *p, unsigned char c, unsigned int len)
{

unsigned char *ucp;
unsigned int i;

	for(i = 0, ucp = (unsigned char *)(p) ; i < len ; i++) 
		*ucp++ = c;
}

/*------------------------------------------------------------------------*/
/* Define the driver specific memcpy call so that we have a self
 * contained driver.
 */
static void drvMemcpy(void *dest, void *src, unsigned int len)
{

unsigned char *sp = (unsigned char *)src;
unsigned char *dp = (unsigned char *)dest;
unsigned int i;

	for(i = 0; i < len ; i++) 
		*dp++ = *sp++;

}
#else

	#define drvMemset memset
	#define drvMemcpy memcpy

#endif	/* DRV_MEMLIB */


#if (defined(T1_DRIVER) && defined(DS26528T1)) || \
    (defined(E1_DRIVER) && (defined(DS26528E1) && (!defined(DS26528T1))))


/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* 
 * Define the data structures that are required for the device.
 */

static GDEVICE gdevice[MAX_DEVICES];
static int gdevice_init = 0;



/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* 
 * The Device Specific Routines are defined below.
 */


/* -------------------------------------------------------------------------- */
/* The _device_GlobalReset implements the device specific reset routine.
 * This routine gets call once when the first time any technology issues its
 * reset call.
 *
 * This routine will be called once, the firs time that a device is reset.
 * This routine should issue a soft reset to the device if it 
 * is capible, then intialize all the hardware register to the value it wants
 * to be for the driver.  The setup once and forget about hardware
 * registers should be done here.
 * It IS possible that this routine will be called a 2nd time if a device
 * is not mapped at all, then a new global reset will call this a 2nd time.
 * If the device is completely un-reset, this will get called also.
 */
static int _device_GlobalReset(GDEVICE *d)
{
int retval = 1;
unsigned int i;
DEVICE *dev = (DEVICE *)(d->BaseAdr);
unsigned char *ucp = (unsigned char *)dev;
FRAMER *f = (FRAMER *)(&dev->te1[0]);

	/* Reset the LIUs */

	f->glsrr = 0xff;
	f->glsrr = 0; 
	
	/* Reset the Framer */
	f->gfsrr = 0xff;
	f->gfsrr = 0; 

	f->gtcr1 = (RLOFLTS_SELECT) ? GTCR1_RLOFLTS : 0;

	f->gfcr = ((RCHBCS_SELECT) ? GFCR_RCBCS : 0) |
		((TCHBCS_SELECT) ? GFCR_TCBCS : 0) |
		((RFMSS_SELECT) ? GFCR_RFMSS : 0) |
		((RLOSSFS_SELECT) ? GFCR_RLOSSFS : 0) |
		(GFCR_BPCLK(BACKPLANE_CLOCK)) |
		(GFCR_IBOMS(INTERLEAVE_MODE));

	f->gtcr2 = ((TSSYNIO_SELECT) ? GTCR2_TSSYNIOSEL : 0) |
			((LOS_SELECT) ? GTCR2_LOSS : 0);

	f->gtccr = ((FREQUENCY_SELECT) ? GTCCR_FREQSEL : 0) |
		(GTCCR_MPS(MASTER_PERIOD)) |
		(GTCCR_BPREFSEL(BACKPLANE_REFERENCE)) |
		((BP_FREQUENCY_SELECT) ? GTCCR_BPFREQSEL : 0);

	/* Write the address space to 00h except global 0xF0 - 0xFF */

	for(i = 0; i < 0xF0; i++) 
		*ucp++ = 0;
	ucp += 16;
	for(i = 0; i < 4224; i++) 
		*ucp++ = 0;
	
	return(retval);
}


/* -------------------------------------------------------------------------- */
/* The global unreset should put the device in the unreset state.
 * This state is up to your platform.  By default, we will just call the
 * reset routine.
 */
static int _device_GlobalUNReset(GDEVICE *d)
{
int retval = 1;

	_device_GlobalReset(d);

	return(retval);
}

/* -------------------------------------------------------------------------- */
/* This routine hooks and unhooks the ISR for the chip.  It can be called from
 * any technology driver.  The first one here, will acutually be the
 * driver that hooks up the ISR via the technology CLBK API call.
 * The last one will cause the ISR to be un-hooked.
 */
void NCID_GHOOKISR(GDEVICE *d, NCID_TI ti, int onoff, 
	void (*fooptr)(), void *LnPtr, void *isr)
{

	if(onoff) {
		d->isr_cnt++;
		d->tech_handlers[ti] = isr;

		if(d->isr_cnt == 1) {
			(*fooptr)(LnPtr, d->device_isr, 1);
		} 
	}
	else {
		if(d->isr_cnt == 1) {
			(*fooptr)(LnPtr, d->device_isr, 0);
		} 

		d->isr_cnt--;
	}
}

#if (MAX_GLOBAL_TICKERS	> 0)
/* -------------------------------------------------------------------------- */
/* This routine translates the ticker into a number of ms required
 */
static int get_ms(int ticker)
{
int ms = 0;
	switch(ticker) {

	default:
		break;
	}
	return(ms);
}

/* -------------------------------------------------------------------------- */
/* This routine get called first on each global ticker before the technology
 * handlers get called
 */

static void GlobalTickerHandler(GDEVICE *d, int ticker)
{

	switch(ticker) {

	default:
		break;
	}

	return;
}


/* -------------------------------------------------------------------------- */
/* This is the OSTickerhandler common to all devices of this type.  
 * This routine will call the OSTicker service routines in each of 
 * the driver files 
 */
static void GlobalTickerProc(void *refptr, GDEVICE *d, int ticker)
{
int i;
void (**fooptr)();

	refptr = refptr;	/* trash compiler warning */

	fooptr = d->tickers[ticker].tickerHandler;

	GlobalTickerHandler(d, ticker);

	for(i = 0; i < DRVR_IDX_END; i++, fooptr++) {

		if(*fooptr != NULL)
		   (**fooptr)(d, ticker);
	}
}

/* -------------------------------------------------------------------------- */
/* This routine gets call by each technology driver to request starting 
 * and unstarting of a global OS Ticker.  
 * The variable "ticker" is the id number and has to
 * be in the range [0,MAX_NCI_TICKERS)
 * The first technology to request the global ticker will start the ticker
 * going.  The last technology to free the ticker will cause the ticker to
 * be freed.
 */
void NCID_GHOOKTICKER(GDEVICE *d, NCID_TI ti, int ticker, int onoff,
	void (*fooptr)(), void *LnPtr, void *tech_handler)
{
struct _tickers *p;
int ms;

	p = &d->tickers[ticker];
	ms = get_ms(ticker);

	if(onoff) {
		p->cnt++;
		p->tickerHandler[ti] = tech_handler;

		if(p->cnt == 1) {
			(*fooptr)(LnPtr, GlobalTickerProc, onoff, ticker, 
				ms, &p->handle);
		} 
	}
	else {
		if(p->cnt == 1) {
			(*fooptr)(LnPtr, GlobalTickerProc, onoff, ticker,
				ms, &p->handle);
			p->handle = NULL;
		} 

		p->cnt--;
	}
}
#endif 	/* MAX_GLOBAL_TICKERS */

/* -------------------------------------------------------------------------- */
/* This routine gets called before any of the technology handlers get called.
 * This is where you would read status registers that are done on a global
 * basis.
 */
static int GlobalISRHandler(GDEVICE *d)
{
int check_again = 0;


	return(check_again);
}

/* -------------------------------------------------------------------------- */
/* This is the interrupt handler common to all devices of this type.  
 * This routine will call the interrupt services routines in each of 
 * the driver files 
 */
static void _device_handler(int device)
{
GDEVICE *d = &gdevice[device];
int check_again;
int i;
int (*fooptr)();


	do {
		check_again = GlobalISRHandler(d);

		for(i = 0; i < DRVR_IDX_END; i++) {

			fooptr = d->tech_handlers[i];
		
			if(*fooptr != NULL)
				check_again |= (*fooptr)(d);
		}

	} while (EDGE_TRIG_INTRPT && check_again);

}


/* -------------------------------------------------------------------------- */
/* This is interrupt services routines per each device.
 * These routines call the main routine with an -1 of the device which
 * is interrupting.
 */

#if MAX_DEVICES > 0
static void _device0_handler(void)
{
        _device_handler(0);
}
#endif

#if MAX_DEVICES > 1
static void _device1_handler(void)
{
        _device_handler(1);
}
#endif

#if MAX_DEVICES > 2
static void _device2_handler(void)
{
        _device_handler(2);
}
#endif

#if MAX_DEVICES > 3
static void _device3_handler(void)
{
        _device_handler(3);
}
#endif

#if MAX_DEVICES > 4
static void _device4_handler(void)
{
        _device_handler(4);
}
#endif

#if MAX_DEVICES > 5
static void _device5_handler(void)
{
        _device_handler(5);
}
#endif

#if MAX_DEVICES > 6
static void _device6_handler(void)
{
        _device_handler(6);
}
#endif

#if MAX_DEVICES > 7
static void _device7_handler(void)
{
        _device_handler(7);
}
#endif

#if MAX_DEVICES > 8
static void _device8_handler(void)
{
        _device_handler(8);
}
#endif

#if MAX_DEVICES > 9
static void _device9_handler(void)
{
        _device_handler(9);
}
#endif

#if MAX_DEVICES > 10
static void _device10_handler(void)
{
        _device_handler(10);
}
#endif

#if MAX_DEVICES > 11
static void _device11_handler(void)
{
        _device_handler(11);
}
#endif

#if MAX_DEVICES > 12
static void _device12_handler(void)
{
        _device_handler(12);
}
#endif

#if MAX_DEVICES > 13
static void _device13_handler(void)
{
        _device_handler(13);
}
#endif

#if MAX_DEVICES > 14
static void _device14_handler(void)
{
        _device_handler(14);
}
#endif

#if MAX_DEVICES > 15
static void _device15_handler(void)
{
        _device_handler(15);
}
#endif

/*------------------------------------------------------------------------*/
/* This routine maps a line to a particular device and channel, and initializes
 * any data records required to manage interrupts for that particular line.
 * Returns NULL if errored, else returns a pointer to the device.
 * This routine gets call from all technology drivers
 */
GDEVICE *NCID_GDEVICEMAP(void *baseadr)
{
int i;
GDEVICE *d = &gdevice[0];

	/* if the first is uninitialized then nothing is initialized
	 */
	if (!gdevice_init) {
		gdevice_init = 1;

		drvMemset(d, 0, sizeof(gdevice));

		/* record info for when we hook interrupts during the INIT call
		 */
		gdevice[0].device_isr = _device0_handler;

#if MAX_DEVICES > 1
		gdevice[1].device_isr = _device1_handler;
#endif
#if MAX_DEVICES > 2
		gdevice[2].device_isr = _device2_handler;
#endif
#if MAX_DEVICES > 3
		gdevice[3].device_isr = _device3_handler;
#endif
#if MAX_DEVICES > 4
		gdevice[4].device_isr = _device4_handler;
#endif
#if MAX_DEVICES > 5
		gdevice[5].device_isr = _device5_handler;
#endif
#if MAX_DEVICES > 6
		gdevice[6].device_isr = _device6_handler;
#endif
#if MAX_DEVICES > 7
		gdevice[7].device_isr = _device7_handler;
#endif
#if MAX_DEVICES > 8
		gdevice[8].device_isr = _device8_handler;
#endif
#if MAX_DEVICES > 9
		gdevice[9].device_isr = _device9_handler;
#endif
#if MAX_DEVICES > 10
		gdevice[10].device_isr = _device10_handler;
#endif
#if MAX_DEVICES > 11
		gdevice[11].device_isr = _device11_handler;
#endif
#if MAX_DEVICES > 12
		gdevice[12].device_isr = _device12_handler;
#endif
#if MAX_DEVICES > 13
		gdevice[13].device_isr = _device13_handler;
#endif
#if MAX_DEVICES > 14
		gdevice[14].device_isr = _device14_handler;
#endif
#if MAX_DEVICES > 15
		gdevice[15].device_isr = _device15_handler;
#endif

		for (d = gdevice, i = 0; i < MAX_DEVICES; i++, d++) {
			d->id = i;
		}
	}


	/* First, See if device is already allocated
	 * This is done by the base address of the chip
	 */
	for (d = gdevice, i = 0; i < MAX_DEVICES; i++, d++) {

		if (d->init && (d->BaseAdr == baseadr)) {
			d->mapCnt++;
			return(d);
		}
	}

	/* OK, this is a new chip, find a location and allocate it 
	 */
	for (d = gdevice, i = 0; i < MAX_DEVICES; i++, d++) {
		/* init the device information
		 */
		if (!d->init) {
			d->init = 1;
			d->BaseAdr = baseadr;
			d->mapCnt++;
			return(d);
		}
	}

	/* No room at the inn, so return null 
	 */
	return(NULL);
}


/*------------------------------------------------------------------------*/
/* This routine performs the unmap function and marks the
 * entire device when all mapping has been cleared 
 * This routine gets call from all technology drivers
 */
int NCID_GDEVICEUNMAP(GDEVICE *d)
{

	if(d->mapCnt > 0)
		d->mapCnt--;

	if(d->mapCnt == 0) {
		d->init = 0;
		d->BaseAdr = NULL;
	}

	return(1);
}

/*------------------------------------------------------------------------*/
/* This routine performs the general reset duties, but nothing chip
 * specific.  It calls the routine _device_GlobalReset to perform
 * the chip specific duties.
 */

void NCID_GRESET(GDEVICE *d)
{

unsigned long lval;

	lval=INTS_OFF();
	if(!d->resetCnt) {

		_device_GlobalReset(d);

	}
	d->resetCnt++;
	INTS_ON(lval);
}

/*------------------------------------------------------------------------*/
/* This routine performs the general UNreset duties, but nothing chip
 * specific.  It calls the routine _device_GlobalUNReset to perform
 * the chip specific duties.
 */

void NCID_GUNRESET(GDEVICE *d)
{

unsigned long lval;

	lval=INTS_OFF();
	if(d->resetCnt == 1) {

		_device_GlobalUNReset(d);

	}
	d->resetCnt--;
	INTS_ON(lval);
}

#endif
#endif /* Build for Specific Driver */
